
;; Copyright 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (add-to-list 'load-path (expand-file-name "~/lisp"))
  (autoload 'formfeed-hline-mode "formfeed-hline" nil t))

(formfeed-hline-mode 1)
(formfeed-hline-mode 0)
(unload-feature 'formfeed-hline)
(require 'formfeed-hline)
(setq debug-on-error t)



;;-----------------------------------------------------------------------------
;; enriched-mode

(find-file "/usr/share/emacs/23.1/etc/enriched.doc")
(describe-display-table (window-display-table))
(describe-display-table standard-display-table))
(setq foo (window-display-table))

(formfeed-hline-char-table-equal (window-display-table)
				 standard-display-table)

(pp foo (current-buffer))


;;-----------------------------------------------------------------------------
;; parent -- emacs

(progn
  (require 'disp-table)
  (aset standard-display-table ?X (make-vector 3 (make-glyph-code ?#))))

(let ((table (make-display-table)))
  (set-char-table-parent table standard-display-table)
  (set-window-display-table (selected-window) table)))

(set-window-display-table (selected-window) nil)

;;-----------------------------------------------------------------------------
;; parent -- xemacs

(setq global-table (make-display-table))
(aset global-table ?X "#")
(aset global-table ?Y "$")
(add-spec-to-specifier current-display-table global-table)
(remove-specifier current-display-table 'global)
(specifier-spec-list current-display-table 'global)

(setq window-table (make-display-table))
(aset window-table ?X "%")
(add-spec-to-specifier current-display-table window-table (selected-window))
(remove-specifier current-display-table (selected-window))

(mapcar 'car (specifier-specs current-display-table))


;;-----------------------------------------------------------------------------

(pretty-control-l-mode 1)
(pretty-control-l-mode 0)
(split-window-horizontally)
(split-window-vertically)
(setq ctl-arrow nil)

(aref (formfeed-hline--window-display-table (selected-window)) ?X)
(aref standard-display-table ?X)
(eq standard-display-table (char-table-parent (window-display-table)))
(set-char-table-parent (window-display-table) standard-display-table)
(set-char-table-parent (window-display-table) nil)
(formfeed-hline--set-window-display-table (selected-window) nil)

(progn
  (require 'disp-table)
  (aset standard-display-table ?X (vector (make-glyph-code ?!))))
(aset standard-display-table ?X nil)
(set-window-display-table (selected-window) nil)
(window-display-table)
(describe-display-table (window-display-table))
(describe-display-table standard-display-table)

jkdfjskfjksfjks jfklajflkjsdakfl;asdjfkl;sjakfl;jaskl;dfjaskl;fjklds;ajfklsd;ajfklsad;jfskla;jfsal;jfsal;

some thing
some thing

some thing

some thing

some thing
%







set-window-configuration
save-window-excursion


;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))


;;--------------
;; emacs21

(progn
  (setq w (selected-window))
  (setq d (make-display-table))
  (aset d ?\f "xyz")
  (set-window-display-table w d))

(aref (formfeed-hline--window-display-table w) ?\f)

;;-----------------------------------------------------------------------------
;; xemacs

beforeafter

(let* ((window (selected-window))
       (specifier (make-display-table-specifier (list (selected-window)))))
  (set-specifier specifier (make-display-table) window)
  (specifier-instance specifier window))

(progn
  (setq w (selected-window))
  (setq d (make-display-table))
  (aset d ?\f "XXX")
  (aset d ?\f "***")
  (add-spec-to-specifier current-display-table d w)
  (redraw-frame (selected-frame)))


(eq d
    (specifier-instance current-display-table (selected-window)))

(specifier-type current-display-table)
(setq d (specifier-instance current-display-table))
(specifier-instance current-display-table w)

(add-spec-to-specifier current-display-table d 'global)

(set-specifier current-display-table d)

(mapcar 'car (specifier-spec-list current-display-table))



      (vconcat (mapcar
                (lambda (c)
                  (formfeed-hline--make-glyph-code c 'escape-glyph))
                (concat "^L " (make-string dashes ?-)))))




(eval-after-load "lisp-mode" '(setq foo 1))
(mapcar 'car load-history)
(prin1 load-history (current-buffer))
(assoc "lisp-mode" load-history)
(assoc "emacs-lisp-mode" load-history)
(require 'lisp-mode)

(progn
  (eval-after-load "apropos" '(setq foo 1))
  foo)

(dolist (l load-history)
  (insert (format "%S\n" (car l))))"/home/gg/lisp/formfeed-hline.el"

;;-----------------------------------------------------------------------------
;; formfeed-hline-char-table-equal

(formfeed-hline-char-table-equal (make-display-table) (make-display-table))

(let ((table1 (make-display-table)))
  (aset table1 ?X [?#])
  (let (lst)
    (map-char-table (lambda (chars value)
                      (if value
                          (push (cons chars value) lst)))
                    table1)
    (nreverse lst)))

(let ((table1 (make-display-table)))
  (aset table1 ?X [?#])
  (formfeed-hline-char-table-equal table1 (make-display-table)))

;;-----------------------------------------------------------------------------
;; pp-c-l.el

(let ((filename "/down/el/pp-c-l.el"))
  (when (file-exists-p filename)
    (autoload 'pretty-control-l-mode filename nil t)))

(setq pp^L-^L-string-function
      (lambda (win)
        (make-string (1- (window-width win)) ?_)))

(pretty-control-l-mode 1)

URL `http://www.emacswiki.org/cgi-bin/wiki/PrettyControlL'
    pp-c-l.el
URL `http://www.emacswiki.org/emacs/OverlayControlL'
    A code fragment using overlays.
URL `http://www.emacswiki.org/emacs/PageBreaks'
    Code fragments for Emacs and XEmacs.


;;-----------------------------------------------------------------------------
;; unused

(defun formfeed-hline--standard-display-table ()
  "Return the `standard-display-table'.
In xemacs this means the 'global specifier."
  (if (eval-when-compile (boundp 'standard-display-table))
      standard-display-table
    (cdar (specifier-spec-list current-display-table 'global))))

;;-----------------------------------------------------------------------------
;; emacs20

;; define-minor-mode -- emacs21 style
;; window-list -- new in emacs21
;; \n in display table string no good, would have to omit

(eval-when-compile
  (unless (fboundp 'push)
    (require 'cl))) ;; emacs20

(progn
  (add-to-list 'load-path (expand-file-name "~/lisp"))
  (autoload 'formfeed-hline-mode "formfeed-hline" nil t)

  (defmacro define-minor-mode (mode doc &rest body)
    (let* (global
	   init-value
	   (mode-name
	    (if (string-match "-mode\\'" (symbol-name mode))
		(symbol-name mode)
	      (concat (symbol-name mode) "-mode")))
	   (hook (intern (concat mode-name "-hook")))
	   (hook-on (intern (concat mode-name "-on-hook")))
	   (hook-off (intern (concat mode-name "-off-hook"))))

      (when (eq :global (car body))
	(setq global (cadr body))
	(setq body (cddr body)))
      '(pp 
	  (get-buffer-create "x"))

       `(progn
	  (easy-mmode-define-minor-mode ,mode ,doc ,init-value)

	  (defun ,mode (&optional arg)
	    ,doc
	    (interactive "P")
	    (let ((old-mode ,mode))
	      (setq ,mode
		    (if arg
			(or (listp arg);; C-u alone
			    (> (prefix-numeric-value arg) 0))
		      (not ,mode)))
	      ,@body
	      (and ,hook
		   (not (equal old-mode ,mode))
		   (run-hooks ',hook))
	      (and ,hook-on
		   ,mode
		   (run-hooks ',hook-on))
	      (and ,hook-off
		   (not ,mode)
		   (run-hooks ',hook-off))))

	  '(makunbound ',mode)
	  '(defvar ,mode ,init-value ,doc))))

  (defun window-list (&optional frame minibuf)
    (unless frame
      (setq frame (selected-frame)))
    (let (ret)
      (walk-windows (lambda (window)
		      (if (eq (window-frame window) frame)
			  (push window ret)))
		    minibuf)
      ret))

  (setq debug-on-error t)
  (formfeed-hline-mode 1))

(formfeed-hline-mode 0)
(formfeed-hline-mode 1)
		  

abc

