#!/usr/bin/perl -w

# Copyright 2008, 2009, 2017 Kevin Ryde.
#
# This file is part of miscbits-el.
#
# miscbits-el is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3, or (at your option) any later
# version.
#
# miscbits-el is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with miscbits-el; see the file COPYING.  Failing that, go to
# <http://www.gnu.org/licenses/>.

use strict;
use warnings;
use File::Find;
use IO::Uncompress::Gunzip;

# my @files = glob ('/usr/share/man/man*/*');
my @files;
find (sub { if (-f $File::Find::name) {
              push @files, $File::Find::name;
            }
          }, '/usr/share/man');


foreach my $file (@files) {
  my $contents;
  IO::Uncompress::Gunzip::gunzip ($file, \$contents);
  # my $contents = `zcat $file`;
  # $contents =~ s/^\.\\".*//mg;

  my @lines = split /\n/, $contents;
  @lines = grep !/^\.?\\"/, @lines;

  my @coding = grep /\bcoding:/, @lines;
  if (@coding) {
    print "$file\n";
    foreach (@coding) { print "$_\n"; }
  }

#   my @non = grep /[\200-\377]/, @lines;
#   if (@non) {
#     print "$file\n";
#     foreach (@non) { print "$_\n"; }
#   }
}
exit 0;
